package org.yaoqiang.collaboration;

import java.awt.BorderLayout;
import java.awt.event.ActionListener;

import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.JCheckBox;
import javax.swing.JLabel;
import javax.swing.JPanel;

/**
 * CheckboxPanel
 * 
 * @author Shi Yaoqiang(shi_yaoqiang@yahoo.com)
 */
public class CheckboxPanel extends JPanel {

	private static final long serialVersionUID = -756855910716627322L;

	protected JCheckBox jcb;

	public CheckboxPanel(String name) {
		setLayout(new BorderLayout());
		setBorder(BorderFactory.createEmptyBorder(5, 5, 5, 5));

		JLabel jl = new JLabel(" " + name);

		jcb = new JCheckBox();
		jcb.setBorder(BorderFactory.createEmptyBorder());

		add(jcb, BorderLayout.WEST);
		add(Box.createHorizontalGlue(), BorderLayout.EAST);
		add(jl, BorderLayout.CENTER);
	}

	public void addActionListener(ActionListener l) {
		jcb.addActionListener(l);
	}

	public boolean isSelected() {
		return jcb.isSelected();
	}

	public void setSelected(boolean b) {
		jcb.setSelected(b);
	}

	public void setEnabled(boolean b) {
		super.setEnabled(b);
		jcb.setEnabled(b);
	}
}
